#!/bin/sh -
#@ 1. Read README.
#@ 2. Use this script to join the source ATF file stubs with the test function
#@    bodies into standalone ATF(7) test programs.

[ -d t-atf ] || {
	echo >&2 'Wrong location'
	exit 1
}
[ ! -d atf-tests ] || {
	echo >&2 'Please remove atf-tests/ first'
	exit 2
}

cp -R t-atf atf-tests || {
	echo >&2 'Failed to cp -R t-atf atf-tests'
	exit 3
}

cd atf-tests
for i in *.c; do
	< ${i} awk '
		/ATF-INCLUDE-SHARED/ {
			f = substr($2, 2, length($2) - 2)
			print "/* >> atf-join.sh included from " f " >> */"
			system("cat " f)
			print "/* << atf-join.sh included from " f " << */"
			next
		}
		{print}
	' > ${i}.new
	mv ${i}.new ${i}
done

echo 'The standalone ATF(7) test sources can be found in atf-tests/'
