/*	$NetBSD$	*/

/*-
 * Copyright (c) 2013 The NetBSD Foundation, Inc.
 * All rights reserved.
 *
 * This code is derived from software contributed to The NetBSD Foundation
 * by Steffen Nurpmeso.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#define F(N, NL)	\
ssize_t \
__TXT_FUN(N)(char const *s __TXT_LOC_DECL) \
{\
	_TXT_TXTT_DECL(t) \
	_TXT_BOUNDT_DECL(mbs) \
	size_t l; \
	ssize_t cl; \
\
	_DIAGASSERT(s != NULL); \
\
	l = strlen(s); \
	if ((cl = l) > 0) { \
		_TXT_TXTT_CREAT(t); \
		_TXT_BOUNDT_CREAT(mbs); \
		cl = __TXT_PEEKSBOUND(t, s, l, mbs); \
		if (cl >= 0 && ! __TXT_ISTXY(N, t, s, cl)) \
			cl = 0; \
		_TXT_BOUNDT_GUT(mbs); \
		_TXT_TXTT_GUT(t); \
	} \
	return cl; \
} \
\
ssize_t \
__TXT_FUN(NL)(char const *s, size_t n __TXT_LOC_DECL) \
{\
	_TXT_TXTT_DECL(t) \
	_TXT_BOUNDT_DECL(mbs) \
	ssize_t cl; \
\
	_DIAGASSERT(s != NULL); \
\
	if ((cl = n) > 0) { \
		_TXT_TXTT_CREAT(t); \
		_TXT_BOUNDT_CREAT(mbs); \
		cl = __TXT_PEEKSBOUND(t, s, n, mbs); \
		if (cl >= 0 && ! __TXT_ISTXY(N, t, s, cl)) \
			cl = 0; \
		_TXT_BOUNDT_GUT(mbs); \
		_TXT_TXTT_GUT(t); \
	} \
	return cl; \
}

F(alnum, lalnum)
F(alpha, lalpha)
#if 0 /* XXX istascii(): not portable, only SUPPORT_LEVEL>3, <=U+007F ? */
F(ascii, lascii)
#endif
F(blank, lblank)
F(cntrl, lcntrl)
F(digit, ldigit)
F(graph, lgraph)
F(lower, llower)
F(print, lprint)
F(punct, lpunct)
F(space, lspace)
F(upper, lupper)
F(xdigit,lxdigit)
