/*	$NetBSD$	*/

/*-
 * Copyright (c) 2013 The NetBSD Foundation, Inc.
 * All rights reserved.
 *
 * This code is derived from software contributed to The NetBSD Foundation
 * by Steffen Nurpmeso.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <text.h>

#if defined LIBC_SCCS && ! defined lint
__RCSID("$NetBSD$");
#endif

#include "local.h"

/*
 * Get length of string.
 * (Do not examine more than n bytes of s.)
 * Only complete characters will be searched;
 * if s ends with an illegal or incomplete sequence, a negative value is
 * returned, and the value denotes the failing byte, counting from 1.
 * If charcnt is not NULL, it'll be set to the count of
 * multibyte/multi-codepoint characters that have been seen (before the
 * failure).
 */

#define __TXT_LOC_DECL
#define __TXT_PEEKSBOUND	_TXT_PEEKSBOUND

#undef __TXT_FUN
#define __TXT_FUN		txtlen
#define __TXT_NARG
#include "_len.h"

#undef __TXT_FUN
#define __TXT_FUN		txtnlen
#undef __TXT_NARG
#define __TXT_NARG		, size_t n
#define __TXT_N_N
#include "_len.h"

#ifdef TEXT_SUPPORT_XLOCALE
# undef __TXT_LOC_DECL
# define __TXT_LOC_DECL		, _TXT_LOC_DECL
# undef __TXT_PEEKSBOUND
# define __TXT_PEEKSBOUND	_TXT_PEEKSBOUND_L

# undef __TXT_FUN
# define __TXT_FUN		txtlen_l
# undef __TXT_NARG
# define __TXT_NARG
# undef __TXT_N_N
# include "_len.h"

# undef __TXT_FUN
# define __TXT_FUN		txtnlen_l
# undef __TXT_NARG
# define __TXT_NARG		, size_t n
# define __TXT_N_N
# include "_len.h"
#endif
