/* $NetBSD$ */

/*
 * Written by Steffen Nurpmeso.
 * Public domain.
 */

#include <atf-c.h>

#include "../t-body/t_txtcmp.h" /* ATF-INCLUDE-SHARED */

ATF_TC(txtcmp_go);
ATF_TC_HEAD(txtcmp_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtcmp(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtcmp_l_go);
ATF_TC_HEAD(txtcmp_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtcmp_l(3) to-go");
}
#endif

ATF_TC(txtncmp_go);
ATF_TC_HEAD(txtncmp_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtncmp(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtncmp_l_go);
ATF_TC_HEAD(txtncmp_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtncmp_l(3) to-go");
}
#endif

ATF_TC(txtcasecmp_go);
ATF_TC_HEAD(txtcasecmp_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtcasecmp(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtcasecmp_l_go);
ATF_TC_HEAD(txtcasecmp_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtcasecmp_l(3) to-go");
}
#endif

ATF_TC(txtncasecmp_go);
ATF_TC_HEAD(txtncasecmp_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtncasecmp(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtncasecmp_l_go);
ATF_TC_HEAD(txtncasecmp_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtncasecmp_l(3) to-go");
}
#endif

ATF_TP_ADD_TCS(tp)
{
	ATF_TP_ADD_TC(tp, txtcmp_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtcmp_l_go);
#endif
	ATF_TP_ADD_TC(tp, txtncmp_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtncmp_l_go);
#endif

	ATF_TP_ADD_TC(tp, txtcasecmp_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtcasecmp_l_go);
#endif
	ATF_TP_ADD_TC(tp, txtncasecmp_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtncasecmp_l_go);
#endif

	return atf_no_error();
}
