/* $NetBSD$ */

/*
 * Written by Steffen Nurpmeso.
 * Public domain.
 */

#include <atf-c.h>

#include "../t-body/t_txtstr.h" /* ATF-INCLUDE-SHARED */

ATF_TC(txtstr_go);
ATF_TC_HEAD(txtstr_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtstr(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtstr_l_go);
ATF_TC_HEAD(txtstr_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtstr_l(3) to-go");
}
#endif

ATF_TC(txtllstr_go);
ATF_TC_HEAD(txtllstr_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtllstr(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtllstr_l_go);
ATF_TC_HEAD(txtllstr_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtllstr_l(3) to-go");
}
#endif

ATF_TC(txtcasestr_go);
ATF_TC_HEAD(txtcasestr_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtcasestr(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtcasestr_l_go);
ATF_TC_HEAD(txtcasestr_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtcasestr_l(3) to-go");
}
#endif

ATF_TC(txtllcasestr_go);
ATF_TC_HEAD(txtllcasestr_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtllcasestr(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtllcasestr_l_go);
ATF_TC_HEAD(txtllcasestr_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtllcasestr_l(3) to-go");
}
#endif

ATF_TC(txtrstr_go);
ATF_TC_HEAD(txtrstr_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtrstr(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtrstr_l_go);
ATF_TC_HEAD(txtrstr_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtrstr_l(3) to-go");
}
#endif

ATF_TC(txtllrstr_go);
ATF_TC_HEAD(txtllrstr_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtllrstr(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtllrstr_l_go);
ATF_TC_HEAD(txtllrstr_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtllrstr_l(3) to-go");
}
#endif

ATF_TC(txtrcasestr_go);
ATF_TC_HEAD(txtrcasestr_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtrcasestr(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtrcasestr_l_go);
ATF_TC_HEAD(txtrcasestr_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtrcasestr_l(3) to-go");
}
#endif

ATF_TC(txtllrcasestr_go);
ATF_TC_HEAD(txtllrcasestr_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtllrcasestr(3) to-go");
}

#ifdef TEXT_SUPPORT_XLOCALE
ATF_TC(txtllrcasestr_l_go);
ATF_TC_HEAD(txtllrcasestr_l_go, tc)
{
        atf_tc_set_md_var(tc, "descr", "txtllrcasestr_l(3) to-go");
}
#endif

ATF_TP_ADD_TCS(tp)
{
	/*
	 * Forward
	 */
	ATF_TP_ADD_TC(tp, txtstr_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtstr_l_go);
#endif
	ATF_TP_ADD_TC(tp, txtllstr_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtllstr_l_go);
#endif

	ATF_TP_ADD_TC(tp, txtcasestr_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtcasestr_l_go);
#endif
	ATF_TP_ADD_TC(tp, txtllcasestr_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtllcasestr_l_go);
#endif

	/*
	 * Reverse
	 */
	ATF_TP_ADD_TC(tp, txtrstr_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtrstr_l_go);
#endif
	ATF_TP_ADD_TC(tp, txtllrstr_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtllrstr_l_go);
#endif

	ATF_TP_ADD_TC(tp, txtrcasestr_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtrcasestr_l_go);
#endif
	ATF_TP_ADD_TC(tp, txtllrcasestr_go);
#ifdef TEXT_SUPPORT_XLOCALE
	ATF_TP_ADD_TC(tp, txtllrcasestr_l_go);
#endif

	return atf_no_error();
}
