/*
 * Fake those atf(7) functions that are used in the shared test bodies,
 * so that the standalone version work by themselves.
 *
 * Written by Steffen Nurpmeso.
 * Public domain.
 */

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

#define ATF_TC_BODY(FUN, TC)	static void FUN(void); static void FUN(void)

static inline void	atf_tc_fail(char const *fmt, ...);

static inline void
atf_tc_fail(char const *fmt, ...)
{
	va_list va;

	va_start(va, fmt);
	vfprintf(stderr, fmt, va);
	va_end(va);
	exit(1);
}
